<template>
	<s-layout class="set-wrap" title="佣金转消费分" :bgStyle="{ color: '#FFF' }">
		<uni-forms :model="state.model" :rules="state.rules" validateTrigger="bind" labelPosition="left" border
			class="form-box" labelWidth='200' ref="FormRef">
			<view class="bg-white ss-p-x-30">
				<uni-forms-item name="quota" label="消费分" :required="true">
					<uni-easyinput v-model="state.model.quota" type="number"
						placeholder="请输入转换金额" :inputBorder="false" :clearable="false" @input="validateInput" />
				</uni-forms-item>


			</view>
		</uni-forms>
		<view class="ss-flex ss-row-center ss-col-center ss-m-t-30">
			您当前可转换的佣金额度:<text class="text-red">{{currentQuota}}</text>
			<!-- <button class="ss-m-l-10 all-btn " @click="useAllPonints">全部</button> -->

		</view>
		<su-fixed bottom placeholder bg="none">
			<view class="footer-box ss-p-20 ss-flex">
				<button class="ss-rest-button btn" @tap="onSubmit">确定</button>
			</view>
		</su-fixed>

	</s-layout>
</template>


<script setup>
	import {
		computed,
		reactive,
		onBeforeMount,
		ref,
		unref,
		watch,
		nextTick
	} from 'vue';
	import sheep from '@/sheep';
	import {
		clone
	} from 'lodash';
	import {
		onLoad
	} from '@dcloudio/uni-app';
	import {
		points2point
	} from '@/sheep/hooks/useGoods';
	import {
		email
	} from '@/sheep/validate/form';

	import AuthUtil from '@/sheep/api/member/auth';
	import ConsumptionApi from '@/sheep/api/distri/consumption';
	import {
		showAuthModal,
	} from '@/sheep/hooks/useModal';
	const userInfo = computed(() => sheep.$store('user').userInfo);
	const userWallet = computed(() => sheep.$store('user').userWallet);
	const state = reactive({

		model: {
			quota: undefined,
		},
		rules: {
			quota: {
				rules: [{
					required: true,
					errorMessage: '转换金额不能为空',
				}, 
				{
				  validateFunction: function (rule, value, data, callback) {
				    if (value<=0) {
				      callback('转换金额不能小于等于0');
				    }
				    return true;
				  },
				},
				],
			},
		}
	});
	const currentQuota = computed(() => points2point(userWallet.value.integralDO.currentQuota));
	
	async function validateInput(value) {
		// 确保输入是整数
		const intValue = parseInt(value);
		const strPoints = value.toString()
		const [integerPart, decimalPart] = strPoints.split('.')
		if (decimalPart) {
			nextTick(() => {
				state.model.quota = integerPart;
			});
		}
		
		if (intValue > parseInt(currentQuota.value)) {
			nextTick(() => {
				state.model.quota = parseInt(currentQuota.value); 
			});

		} else {
			nextTick(() => {
				state.model.quota = intValue; 
			});
		}
	}

	// 提交审核
	const FormRef = ref(null);
	const onSubmit = async () => {
		// 参数校验
		const validate = await unref(FormRef)
			.validate()
			.catch((error) => {
				console.log('error: ', error);
			});
		if (!validate) {
			return;
		}
		uni.showModal({
			title: '提示',
			content: '佣金转为消费分后不可逆，是否转换？',
			
			success: async function(res) {
				if (!res.confirm) {
					return;
				}
				const {
					data,
					code
				} = await ConsumptionApi.quotaTransition(state.model.quota);
				if (code === 0) {
					uni.showToast({
						title: '转换成功',
						icon: 'none',
						duration: 2000
					});
					uni.$emit('consumptionTransfersComplete');
					sheep.$router.redirect('/pages/user/wallet/score')
				}
			},
		});
		
	}

	const isLogin = computed(() => sheep.$store('user').isLogin);
	// 监听到在这个页面登陆，并刷新页面
	watch(
		() => isLogin.value,
		(newVal) => {
			if (newVal) {
				window.location.reload()
			}
		}, {
			deep: true, // 深度监听
		},
	);

	onLoad(async (options) => {
		if (!isLogin.value) {
			showAuthModal();
		}
	});
</script>

<style lang="scss" scoped>
	.code-btn-start {

		width: 158rpx;
		height: 56rpx;
		line-height: normal;
		background: linear-gradient(90deg, var(--ui-BG-Main), var(--ui-BG-Main-gradient));
		border-radius: 28rpx;
		font-size: 26rpx;
		font-weight: 500;
		color: #fff;

	}

	.disabled {
		border: 1px solid #f7f7f7;
	}

	.icon {
		display: flex;
		align-items: center;
		margin-right: 7rpx
	}

	.icon image {
		width: 35rpx;
		height: 35rpx;
	}

	:deep() {

		.file-picker__progress {
			height: 0 !important;
		}

		.uni-list-item__content-title {
			font-size: 28rpx !important;
			color: #333333 !important;
			line-height: normal !important;
		}

		.uni-icons {
			font-size: 40rpx !important;
		}

		.is-disabled {
			color: #333333;
		}
	}

	:deep(.disabled) {
		opacity: 1;
	}

	.gender-name {
		font-size: 28rpx;
		font-weight: 500;
		line-height: normal;
		color: #333333;
	}

	.title-box {
		font-size: 28rpx;
		font-weight: 500;
		color: #666666;
		line-height: 100rpx;
	}

	.btn {
		width: 710rpx;
		height: 80rpx;
		background: linear-gradient(90deg, var(--ui-BG-Main), var(--ui-BG-Main-gradient));
		border-radius: 40rpx;
		font-size: 30rpx;
		font-weight: 500;
		color: $white;
	}

	.btn-two {
		width: 310rpx;
		height: 80rpx;
		background: linear-gradient(90deg, var(--ui-BG-Main), var(--ui-BG-Main-gradient));
		border-radius: 40rpx;
		font-size: 30rpx;
		font-weight: 500;
		color: $white;
	}

	.radio-dark {
		filter: grayscale(100%);
		filter: gray;
		opacity: 0.4;
	}

	.content-img {
		border-radius: 50%;
	}

	.header-box-content {
		position: relative;
		width: 160rpx;
		height: 160rpx;
		overflow: hidden;
		border-radius: 50%;
	}

	.avatar-action {
		position: absolute;
		left: 50%;
		transform: translateX(-50%);
		bottom: 0;
		z-index: 1;
		width: 160rpx;
		height: 46rpx;
		background: rgba(#000000, 0.3);

		.avatar-action-btn {
			width: 160rpx;
			height: 46rpx;
			font-weight: 500;
			font-size: 24rpx;
			color: #ffffff;
		}
	}

	// 绑定项
	.account-list {
		background-color: $white;
		height: 100rpx;
		padding: 0 20rpx;

		.list-img {
			width: 40rpx;
			height: 40rpx;
			margin-right: 10rpx;
		}

		.list-name {
			font-size: 28rpx;
			color: #333333;
		}

		.info {
			.avatar {
				width: 38rpx;
				height: 38rpx;
				border-radius: 50%;
				overflow: hidden;
			}

			.name {
				font-size: 28rpx;
				font-weight: 400;
				color: $dark-9;
			}
		}

		.bind-box {
			width: 100rpx;
			height: 50rpx;
			line-height: normal;
			display: flex;
			justify-content: center;
			align-items: center;
			font-size: 24rpx;

			.bind-btn {
				width: 100%;
				height: 100%;
				border-radius: 25rpx;
				background: #f4f4f4;
				color: #999999;
			}

			.relieve-btn {
				width: 100%;
				height: 100%;
				border-radius: 25rpx;
				background: var(--ui-BG-Main-opacity-1);
				color: var(--ui-BG-Main);
			}
		}
	}

	.list-border {
		font-size: 28rpx;
		font-weight: 400;
		color: #333333;
		border-bottom: 2rpx solid #eeeeee;
	}

	image {
		width: 100%;
		height: 100%;
	}
</style>